package com.example;

import com.vaadin.server.VaadinServlet;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.stereotype.Service;

import javax.servlet.ServletContext;
import java.io.IOException;
import java.io.InputStream;
import java.util.Arrays;
import java.util.jar.Attributes;
import java.util.jar.Manifest;

import static java.lang.Package.*;

@SpringBootApplication
public class DemoApplication {

	private static String version;
	public static void main(String[] args) {
		SpringApplication.run(DemoApplication.class, args);
	}

	@Service
	public static class MyService {
//		String version = com.example.DemoApplication.class.getPackage().getImplementationVersion();
//        String vendor = com.example.DemoApplication.class.getPackage().getSpecificationVendor();

		public String sayHi() {
//			version = getClass().getPackage().getSpecificationVersion();
			String rootPath  = getClass().getProtectionDomain().getCodeSource().getLocation().getPath();
			return "Hello Spring Initializer; Version: " + version + " (" + com.example.DemoApplication.class.getPackage().getName() + ") " + rootPath;
		}

        public void allPackages() {
			Package[] localPackages = getPackages();
			String[] packageNames = new String[localPackages.length];
			for (int i = 0; i < localPackages.length; i++) {
				packageNames[i] = localPackages[i].toString();
			}
			Arrays.sort(packageNames);
            System.out.println("PACKAGES: ");
			System.out.println("VERSION: " + getClass().getPackage().getImplementationVersion() + getClass().getPackage().getSpecificationVersion() + getClass().getPackage().getSpecificationVendor());
			for (int i = 0; i < packageNames.length; i++) {
//				if (!packageNames[i].contains("Java Platform API"))
                if (packageNames[i].contains("com.example"))
					System.out.println(packageNames[i]);
			}
		}

		public void setVersion() {
			version = null;
			try {
				Attributes attr;
				ServletContext servletContext = VaadinServlet.getCurrent().getServletContext();

				InputStream inputStream = servletContext.getResourceAsStream("/META-INF/MANIFEST.MF");
				Manifest manifest = new Manifest(inputStream);
				attr = manifest.getMainAttributes();
				version = attr.getValue("Specification-Version");
				System.out.println("Version (from MANIFEST.MF):" + version);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		public String getVersion() {
			return version;
		}
	}
}
